{% extends "page.html" %}
{% block left_nav %}
{% endblock left_nav %}
{% block clock %}
{% endblock clock %}
{% block content %}
    <section>
        <div class="container mx-auto my-3 py-3 text-center {{ action_class or '' }}">
            <h1>
                {{ message.splitlines()|join("<br />"|safe) }}
            </h1>
        </div>
        <div class="container mx-auto mt-3">
            {% if qr_code %}
                <div class="row align-items-center">
                    <div class="col-6 font-weight-bold text-right">
                        <h5>
                            No CRSid is associated with<br>
                            this card. Scan the QR code<br>
                            with your phone to confirm<br>
                            your identity using Raven.
                        </h5>
                    </div>
                    <div class="col-6">
                        {{ qr_code }}
                    </div>
                </div>
            {% endif %}
            {% if data_mode == "edit" %}
                <form
                    class="col-sm-9 mx-auto {{ "nag-check" if nag_check }}"
                    action="{{ url_for('view.update') }}"
                    method="post"
                    id="edit-details">
                    {% if buildings|length > 1 %}
                    <h3>Buildings (select all that you are working in today)</h3>
                    {% for building in buildings %}
                        <div class="form-check form-check-inline form-control-lg btn-group-toggle my-2" data-toggle="buttons">
                            <label
                                class="form-check-label building-label btn btn-outline-sign-in btn-lg {{ 'active' if building in person_data.buildings }}"
                                for="{{ building }}">
                                <input
                                    class="form-check-input building-checkbox"
                                    type="checkbox"
                                    name="buildings"
                                    id="{{ building }}"
                                    value="{{ building }}"
                                    {{ 'checked' if building in person_data.buildings }}/>
                                {{ building }}
                            </label>
                        </div>
                    {% endfor %}
                    {% endif %}
                    <div class="my-2 py-2"></div>
                    <div class="row my-3">
                        <div class="col text-left">
                            <h3 class="text-left">
                                {% if g.kiosk %}
                                    Tap to edit your details
                                {% elif g.admin %}
                                    Update details
                                {% else %}
                                    Update your details
                                {% endif %}
                            </h3>
                        </div>
                        <div class="col text-right">
                            <button type="reset" id="btn-reset" class="btn btn-secondary btn-lg">Reset</button>
                            {# Only kiosks should timeout automatically on the edit screen #}
                            {% if g.kiosk %}
                                <button
                                        type="submit"
                                        id="btn-finished"
                                        class="btn btn-primary btn-lg timeout"
                                        name="update"
                                        value="true"
                                        data-timeout="{{ timeout or 5 }}">Finished
                                </button>
                            {% else %}
                                <button
                                        type="submit"
                                        id="btn-finished"
                                        class="btn btn-primary btn-lg"
                                        name="update"
                                        value="true">Finished
                                </button>
                            {% endif %}
                        </div>
                    </div>
                    <div class="form-group row mt-3">
                        <div class="col-sm-4">
                            <label for="input_name" class="h4">Display Name</label>
                        </div>
                        <div class="col-sm-8">
                            <input
                                type="text"
                                class="form-control form-control-lg {{ 'is-valid' if not person_data.crsid }}"
                                name="name"
                                {% if "name" in configuration.HIGHLIGHT_FIELDS %}
                                    data-highlight="true"
                                {% endif %}
                                id="input_name"
                                maxlength="128"
                                placeholder="Desired display name"
                                value="{{ person_data.name or '' }}">
                            <div class="invalid-feedback text-right">
                                A display name <strong>must</strong> be supplied
                            </div>
                            {% if not person_data.crsid %}
                                <div class="valid-feedback text-right">
                                    Please <strong>double-check</strong> your name
                                </div>
                            {% endif %}
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-sm-4">
                            <label for="input_rooms" class="h4">Rooms</label>
                        </div>
                        <div class="col-sm-8">
                            <input
                                type="text"
                                class="form-control form-control-lg"
                                name="rooms"
                                {% if "rooms" in configuration.HIGHLIGHT_FIELDS %}
                                    data-highlight="true"
                                {% endif %}
                                id="input_rooms"
                                maxlength="128"
                                placeholder="All working locations"
                                value="{{ person_data.rooms or '' }}">
                            <div class="invalid-feedback text-right">
                                A working location <strong>must</strong> be supplied
                            </div>
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-sm-4">
                            <label for="input_telephone" class="h4">Contact Phone<br/>
                                <small>public e.g. desk phone</small>
                            </label>
                        </div>
                        <div class="col-sm-8">
                            <input
                                type="text"
                                class="form-control form-control-lg"
                                name="telephone"
                                {% if "telephone" in configuration.HIGHLIGHT_FIELDS %}
                                    data-highlight="true"
                                {% endif %}
                                id="input_telephone"
                                maxlength="128"
                                placeholder="Contact telephone number"
                                value="{{ person_data.telephone or '' }}">
                            <div class="invalid-feedback text-right">
                                A contact telephone number <strong>should</strong> be supplied
                            </div>
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-sm-4">
                            <label for="input_emergency_telephone" class="h4">Emergency Phone<br/>
                                <small>hidden e.g. mobile phone</small>
                            </label>
                        </div>
                        <div class="col-sm-8">
                            <input
                                type="text"
                                class="form-control form-control-lg"
                                name="emergency_telephone"
                                {% if "emergency_telephone" in configuration.HIGHLIGHT_FIELDS %}
                                    data-highlight="true"
                                {% endif %}
                                id="input_emergency_telephone"
                                maxlength="128"
                                placeholder="Emergency telephone number"
                                value="{{ person_data.emergency_telephone or '' }}">
                            <div class="invalid-feedback text-right">
                                An emergency telephone number <strong>must</strong> be supplied
                            </div>
                        </div>
                    </div>
                    {# Show different fields for different clients #}
                    {% if g.kiosk and person_data.crsid %}
                        {# Known user and card at a terminal, just show crsid #}
                        <div class="form-group row">
                            <div class="col-sm-4">
                                <label for="input_crsid" class="h4">Identifier (CRSid)</label>
                            </div>
                            <div class="col-sm-8">
                                <input
                                    type="text"
                                    readonly="readonly"
                                    class="form-control form-control-lg"
                                    id="input_crsid"
                                    name="crsid"
                                    value="{{ person_data.crsid }}">
                            </div>
                        </div>
                        {# Include the mifare when form is submitted #}
                        <input type="hidden" name="mifare" value="{{ person_data.mifare or '' }}">
                    {% elif g.kiosk %}
                        {# User without crsid, offer to assign a new one and show mifare #}
                        <div class="form-group row">
                            <div class="col-sm-4">
                                <label for="input_new_crsid" class="h4">CRSid</label>
                            </div>
                            <div class="col-sm-8">
                                <input
                                    type="text"
                                    class="form-control form-control-lg"
                                    id="input_new_crsid"
                                    name="new_crsid"
                                    {% if "crsid" in configuration.HIGHLIGHT_FIELDS %}
                                        data-highlight="true"
                                    {% endif %}
                                    placeholder="Link with your CRSid for Raven access"
                                    value="">
                                <div class="invalid-feedback text-right">
                                    A CRSid is <strong>needed</strong> to enable Raven login
                                </div>
                                <div class="valid-feedback text-right">
                                    You will be emailed a confirmation link
                                </div>
                            </div>
                        </div>
                        <div class="form-group row">
                            <div class="col-sm-4">
                                <label for="input_mifare" class="h4">Card ID (MIFARE)</label>
                            </div>
                            <div class="col-sm-8">
                                <input
                                    type="text"
                                    readonly="readonly"
                                    class="form-control form-control-lg"
                                    id="input_mifare"
                                    name="mifare"
                                    value="{{ person_data.mifare or '' }}">
                            </div>
                        </div>
                    {% elif g.admin %}
                        {# Admin users can edit all details to update them, including identifiers #}
                        <div class="form-group row">
                            <div class="col-sm-4">
                                <label for="input_crsid" class="h4">Identifier (CRSid)</label>
                            </div>
                            <div class="col-sm-8">
                                <input
                                    type="text"
                                    class="form-control form-control-lg"
                                    id="input_crsid"
                                    name="crsid"
                                    value="{{ person_data.crsid or '' }}">
                            </div>
                        </div>
                        <div class="form-group row">
                            <div class="col-sm-4">
                                <label for="input_mifare" class="h4">Card ID (MIFARE)</label>
                            </div>
                            <div class="col-sm-8">
                                <input
                                    type="text"
                                    class="form-control form-control-lg"
                                    id="input_mifare"
                                    name="mifare"
                                    value="{{ person_data.mifare or '' }}">
                            </div>
                        </div>
                    {% else %}
                        {# Non admin web user doesn't need to see their fixed identifiers #}
                        <input type="hidden" name="crsid" value="{{ person_data.crsid or '' }}">
                        <input type="hidden" name="mifare" value="{{ person_data.mifare or '' }}">
                    {% endif %}
                    {# cardholder is not used, but pass it silently for future systems #}
                    <input type="hidden" name="cardholder" value="{{ person_data.cardholder or '' }}">
                    {% if configuration.ENABLE_INVISIBILITY %}
                        <div class="form-group row">
                            <div class="col-sm-4">
                                <label class="h4">Hide Login Status</label>
                            </div>
                            <div class="col-sm-8 btn-group-toggle" data-toggle="buttons">
                                <label class="form-check-label btn btn-outline-sign-in btn-lg {{ 'active' if person_data.invisible }}">
                                    <input
                                        class="form-check-input"
                                        type="checkbox"
                                        name="invisible"
                                        id="input_invisible"
                                        value="invisible"
                                        {{ 'checked' if person_data.invisible }}/>
                                    Invisible
                                </label>
                            </div>
                        </div>
                    {% endif %}
                    {% if g.admin %}
                        {# Admin only actions carried out on other users #}
                        <div class="row my-3"></div>
                        <div class="row my-3">
                            <div class="col text-left">
                                <h3 class="text-left">Forced actions</h3>
                            </div>
                            <div class="col text-right">
                                <a
                                    href="{{ url_for('view.scan', reader='yellow', crsid=person_data.crsid, mifare=person_data.mifare) }}"
                                    class="btn btn-lg btn-sign-in">Sign in
                                </a>
                                <a
                                    href="{{ url_for('view.scan', reader='purple', crsid=person_data.crsid, mifare=person_data.mifare) }}"
                                    class="btn btn-lg btn-sign-out">Sign out
                                </a>
                            </div>
                        </div>
                        {# !Danger! admin can purge all records #}
                        {# Requires some Bootstrap/JS but stops accidental triggers #}
                        <div class="row my-3"></div>
                        <div class="row my-3">
                            <div class="col text-right">
                                <button type="button" class="btn btn-lg btn-danger" data-toggle="modal" data-target="#confirmDelete">
                                    Delete all records
                                </button>
                            </div>
                        </div>
                        <div class="modal fade" id="confirmDelete" tabindex="-1" role="dialog">
                            <div class="modal-dialog" role="document">
                                <div class="modal-content">
                                    <div class="modal-header">
                                        <h5 class="modal-title">Confirm deletion</h5>
                                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                            <span aria-hidden="true">&times;</span>
                                        </button>
                                    </div>
                                    <div class="modal-body">
                                        <p>
                                            Deleting a user will remove their profile and all actions that
                                            are stored in the database. <strong>If any activity is required for
                                            tracking, it will be impossible to recover after deleting the user.</strong>
                                        </p>
                                    </div>
                                    <div class="modal-footer">
                                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                                        <a
                                            class="btn btn-danger"
                                            href="{{ url_for('view.delete_profile', crsid=person_data.crsid, mifare=person_data.mifare, confirm_delete=True) }}">
                                                Delete
                                        </a>
                                    </div>
                                </div>
                            </div>
                        </div>
                    {% endif %}
                </form>
            {% elif data_mode == "ask" %}
                {# Expects a dict form of a person #}
                <div class="text-center {{ "nag-check" if nag_check }}">
                    <h3>Personal Details</h3>
                    <table class="table table-sm table-bordered w-50 mx-auto">
                        <tr>
                            <th scope="row" class="w-50">Display Name</th>
                            <td class="w-50">{{ person_data.name }}</td>
                        </tr>
                        {% if buildings|length > 1 %}
                            <tr>
                                <th scope="row">Buildings</th>
                                <td>{{ person_data.buildings|join(', ') }}</td>
                            </tr>
                        {% endif %}
                        <tr>
                            <th scope="row">Rooms</th>
                            <td>{{ person_data.rooms }}</td>
                        </tr>
                        <tr>
                            <th scope="row">Contact Phone</th>
                            <td>{{ person_data.telephone }}</td>
                        </tr>
                        <tr>
                            <th scope="row">Emergency Phone</th>
                            <td>{{ person_data.emergency_telephone }}</td>
                        </tr>
                    </table>
                    {% if g.kiosk %}
                        <h3>Ensure your details are up to date at {{ href(url_for("view.index", _external=True)) }}</h3>
                    {% endif %}
                    <a
                        href="{{ url_for('view.scan', reader='edit', mifare=person_data.mifare, crsid=person_data.crsid) }}"
                        class="btn btn-secondary btn-lg text-center">Edit</a>
                    <a
                        href="{{ url_for('view.index') }}"
                        id="btn-finished"
                        class="btn btn-secondary btn-lg text-center timeout"
                        data-timeout="{{ timeout or 5 }}">Finished
                    </a>
                </div>
            {% else %}
                <div class="text-center">
                    <a
                        href="{{ url_for('view.index') }}"
                        id="btn-finished"
                        class="btn btn-secondary btn-lg text-center timeout"
                        data-timeout={{ timeout or 5 }}>Finished
                    </a>
                </div>
            {% endif %}
        </div>
    </section>
{% endblock content %}